Package org.zkoss.zul

## Class WaferMapModel

- java.lang.Object
- - org.zkoss.zul.AbstractChartModel
  - - org.zkoss.zul.WaferMapModel

- All Implemented Interfaces:
    `java.io.Serializable`, `ChartModel`

      public class WaferMapModel
      extends AbstractChartModel

  A semiconductor wafer map data model to be used with wafermap chart. A value of a specified (x,y) on a wafter matrix.
  Since:
    3.5.0
  Author:
    henrichen
  See Also:
    `Chart`, Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `WaferMapModel.IntPair` |

  - ### Field Summary

    - ### Fields inherited from class org.zkoss.zul.AbstractChartModel

      `_listeners`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `WaferMapModel()` | data model to be used with wafermap chart.
    `WaferMapModel​(int xsize, int ysize)` | data model to be used with wafermap chart.
    `WaferMapModel​(int xsize, int ysize, double space)` | data model to be used with wafermap chart.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addValue​(int value, int x, int y)` | Add a value to the given chip at (x,y) (0-based) of the wafer chip matrix.
    `void` | `clear()` | clear the model.
    `java.lang.Object` | `clone()` |
    `java.util.Collection<java.util.Map.Entry<WaferMapModel.IntPair,​java.lang.Number>>` | `getEntrySet()` | Internal Use Only.
    `double` | `getSpace()` | Returns the space between chips, default to 1.
    `java.lang.Number` | `getValue​(int x, int y)` | Returns the value of the given chip at (x,y) of the wafer matrix.
    `int` | `getXsize()` | Returns the x size of the wafer matrix.
    `int` | `getYsize()` | Returns the y size of the wafer matrix.
    `void` | `removeValue​(int x, int y)` | remove the value of the specified x and y.
    `void` | `setXsize​(int xsize)` | Returns the x size of the wafer matrix.
    `void` | `setYsize​(int ysize)` | Returns the y size of the wafer matrix.

    - ### Methods inherited from class org.zkoss.zul.AbstractChartModel

      `addChartDataListener, fireEvent, removeChartDataListener`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### WaferMapModel

          public WaferMapModel()

      data model to be used with wafermap chart.

    - #### WaferMapModel

          public WaferMapModel​(int xsize,
                               int ysize)

      data model to be used with wafermap chart.
      Parameters:
        `xsize` - the x size of the wafer matrix.
        `ysize` - the y size of the wafer matrix.

    - #### WaferMapModel

          public WaferMapModel​(int xsize,
                               int ysize,
                               double space)

      data model to be used with wafermap chart.
      Parameters:
        `xsize` - the x size of the wafer matrix.
        `ysize` - the y size of the wafer matrix.
        `space` - the space between chips.

  - ### Method Detail

    - #### getXsize

          public int getXsize()

      Returns the x size of the wafer matrix.

    - #### getYsize

          public int getYsize()

      Returns the y size of the wafer matrix.

    - #### setXsize

          public void setXsize​(int xsize)

      Returns the x size of the wafer matrix.

    - #### setYsize

          public void setYsize​(int ysize)

      Returns the y size of the wafer matrix.

    - #### getSpace

          public double getSpace()

      Returns the space between chips, default to 1.

    - #### getValue

          public java.lang.Number getValue​(int x,
                                           int y)

      Returns the value of the given chip at (x,y) of the wafer matrix.
      Parameters:
        `x` - the x index of the wafer matrix.
        `y` - the y index of the wafer matrix.
      Returns:
        the value of the given chip at (x,y) of the wafer matrix.

    - #### addValue

          public void addValue​(int value,
                               int x,
                               int y)

      Add a value to the given chip at (x,y) (0-based) of the wafer chip matrix. If the given x or y is bigger than the specified matrix size, the IndexOutOfBoundsException will be thrown.
      Parameters:
        `value` - the chip value on the wafer matrix.
        `x` - the x index to specify the chip on the wafer.
        `y` - the y index to specify the chip on the wafer.

    - #### getEntrySet

          public java.util.Collection<java.util.Map.Entry<WaferMapModel.IntPair,​java.lang.Number>> getEntrySet()

      Internal Use Only. The entrySet of the added values.

    - #### removeValue

          public void removeValue​(int x,
                                  int y)

      remove the value of the specified x and y.
      Parameters:
        `x` - the x index of the wafer matrix.
        `y` - the y index of the wafer matrix.

    - #### clear

          public void clear()

      clear the model.

    - #### clone

          public java.lang.Object clone()

      Overrides:
        `clone` in class `AbstractChartModel`